/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2006, Loune Lam <lpgcritter at nasquan dot com>
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item
ISP Definitions Version 2.0

*/


const __ISPS_JS__ = 1;

const UNIT_B = 0;
const UNIT_KB = 1;
const UNIT_MB = 2;
const UNIT_GB = 3;

const PREF_TYPE_INT = 1;
const PREF_TYPE_STRING = 2;
const PREF_TYPE_BOOL = 4;
const PREF_FLAG_REQUIRED = 8;
const PREF_FLAG_GENERAL = 16;
const PREF_FLAG_LIST_EDITABLE = 32;

var nuSupportedISPs = {
'bigpond': 'Bigpond',
'netspace': 'Netspace',
'tpgi': 'TPG Internet',
'iinet': 'iiNet broadband',
'internode': 'Internode',
'optus': 'OptusNet',
'adam': 'Adam Internet',
'unwired': 'Unwired',
'westnet': 'Westnet',
'chariot': 'Chariot',
'aanet': 'aaNet ADSL',
'exetel': 'eXeTeL',
'onthenet': 'OntheNet',
'netcall': '.Netcall',
'westvic': 'Westvic Broadband',
'gnode': 'G-Node',
'kern': 'Kern Internet',
'comcen': 'ComCen Internet',
'wideband': 'Wideband Networks',
'mackaycs': 'Mackay Computer Services',
//'peopletelecom': 'People Telecom',
'clearnetworks': 'Clear Networks',
'velocitynet': 'Velocity Internet',
'amnet': 'Amnet',
'wildit': 'Wild I&T',
'netxp': 'netXP',
//'activ8me': 'ACTIV8me',
//'aapt': 'AAPT',

'coditel': 'Coditel',
'volia': 'Volia',
}

function nuGetISPInterface(isp) {
	var o;
	o = nuGetISPInterfaceA(isp);
	// if (o == null) try another function in another script file?
	o.id = isp;
	o.name = nuSupportedISPs[isp];
	return o;
}

function nuGetISPInterfaceA(isp) {

	switch(isp) {
	
	
	case 'bigpond': 
		return {
			description: 'Please enter your Usage Allowance!',

			intUnit: UNIT_MB,
			
			prefs: {
				'USERNAME': 'Username',
				'usage-quota': ['Usage Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
			},
			vars: {
			},

			branching: {
				'1,0': null,
				'1,1': null,
				'1,3': 5,
				'2,0': 2,
				'2,1': 5,
				'2,3': 4,
				'3,0': 6,
				'3,1': 5,
				'3,3': 5,
				'4,0': 6,
				'5,0': 100,
			},
			process: [
				//step 0 homepage
				null,
				'GET http://www.bigpond.com/default.asp',
				[/TS=([0-9]+)&TO=([0-9]+)&KID=([0-9]+)&MAC=([a-zA-Z0-9]+)/],

				// step 1 login
				null,
				//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
				'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D{0:1}%26TO%3D{0:2}%26KID%3D{0:3}%26MAC%3D{0:4}%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
				//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttps%253A%252F%252Fmy.bigpond.com%252Fmybigpond%252Fmyaccount%252Fmyusage%252Fdefault.do%26TS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttps%253A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%253FSUCCESS_PAGE%253Dhttps%253A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%253FFORM%253Dbigpond%2526AUTH_REDIR%253Dhttps%25253A%25252F%25252Fmy.bigpond.com%25252Fmybigpond%25252Fmyaccount%25252Fmyusage%25252Fdefault.do%2526TS%253D2006%2526TO%253D20%2526KID%253D1%2526MAC%253D%3B',
				//'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',
				[
					/provided is either incorrect or incomplete/,
					/<b>(You entered an invalid username and password combination. <BR>Due to security precautions any account which has had three unsuccessful attempts to login will be locked out for three hours.)<\/b>/,
					/;URL=([^"]+)/,
					/./,
				],
				
				// step 2 redirect
				function (vars) {
					if (vars['laststep'] == 4)
						vars["1redir"] = vars["4:1"];
					else if (vars['laststep'] == 2)
						vars["1redir"] = vars["2:1"];
					else
						vars["1redir"] = vars["1:1"];
				},
				'GET {1redir|NOESC}',
				[
					/;URL=([^"]+)/,
					/<title>LOG INTO BIGPOND/, // go to old xml
					/https:\/\/account\.bigpond\.com\/broadband\/usage\/secure\/monthlyusage\.do/,
					/\/mybigpond\/myaccount\/myusage\/default\.do/,
				],
				
				// step 3 try old meter
				null,
				'GET https://account.bigpond.com/broadband/usage/secure/monthlyusage.do',
				[
					/Current Bill Period[^`]+?100%">([a-zA-Z0-9 ]+) to ([a-zA-Z0-9 ]+)[^`]+?Current Account Usage:[^`]+?<b>([0-9,\.]+)/,
					/UNABLE TO ACCESS USAGE INFORMATION/, // go to old xml toolbar
					/meter is no longer available at this location/, // go to new usage meter
					/<title>LOG INTO BIGPOND/, // go to old xml
				],
				// step 4 try new meter
				null,
				'GET https://my.bigpond.com/mybigpond/myaccount/myusage/default.do',
				[ 
					/Current Plan:<\/td>[\s]+<td valign="top" nowrap="nowrap">([^<]+)[^`]+?Current Bill Period[^`]+?>([0-9a-zA-Z ]+) - ([0-9a-zA-Z ]+)[^`]+?Current Account Usage[^`]+?<strong>([0-9,\.]+)/,
				],
				// step 5 try old xml toolbar meter
				function(vars) { vars['TIMESTAMP'] = Math.round((new Date()).getTime()/1000); },
				'GETBASIC https://account.bigpond.com/siteminderagent/nocert/{TIMESTAMP}/smgetcred.scc?TYPE=16777217&REALM=$SM$Toolbar&TARGET=$SM$https%3a%2f%2faccount%2ebigpond%2ecom%2fbroadband%2fusage%2ftoolbar%2ftoolbar%2edo?version=1.4',
				[ 
					{
						'XPATHVERIFY': '/bigpond[@version="1.4"]/usage/account',
						'usage': '/bigpond/usage/account/balance',
					}
				],
				
				// step 6 logout
				null,
				'GET http://www.bigpond.com/mybigpond/logout.asp',
				null,

				null
			],

			processVisitUsagePage: 'POST https://telstra.com/siteminderagent/SMLogin/preLogin.do user={USERNAME}&password={PASSWORD}&target=&smauthreason=0&error_target=https%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Fbigpondlogin.asp%3FSUCCESS_PAGE%3Dhttps%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26loginfailure%3D{USERNAME}&final_target=https%3A%2F%2Ftelstra.com%2Ftcoma%2Fsecurity%2Flogin2.asp%3FFORM%3Dbigpond%26AUTH_REDIR%3Dhttp%3A%2F%2Fwww.bigpond.com%2Fmybigpond%2Flogin.asp%3FTS%3D2006%26TO%3D20%26KID%3D1%26MAC%3D%26BPCUSTLOGIN%3DY&postpreservationdata=&generallogondata=SMLogonVersion%3D1.1%3BDebug%3Dfalse%3BReferer%3Dhttp%253A%2F%2Fwww.bigpond.com%2F%3B',

			varMap: {
				'3,0': { // old meter
					'startdate': '3:1',
					'enddate': '3:2',
					'usage': '3:3',
					
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
				'4,0': { // new meter
					'planname': '4:1',
					'startdate': '4:2',
					'enddate': '4:3',
					'usage': '4:4',
					
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
				'5,0': { // old toolbar meter
					
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'3,0': {
					'Usage': '{usage} / {usage-quota}',
				},
				'4,0': {
					'Usage': '{usage} / {usage-quota}',
				},
				'5,0': {
					'Usage': '{usage} / {usage-quota}',
				},
			},
	
		};
	
	case 'netspace':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,2': null,
			},
			process: [

				// step 0
				null,
				'GETBASIC https://usage.netspace.net.au/usage-meter/adslusage?version=2&granularity=MONTH',
				[
					// on/offpeak
					{
						'XPATHVERIFY': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]',
						'planname': '/USAGE/PLAN/@DESCRIPTION',
						
						'startdate': '/USAGE/@START_DATE',
						'enddate': '/USAGE/@END_DATE',

						'upload': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
						'download': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
						'download-quota': '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',
						'uploadpo': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
						'downloadpo': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
						'downloadpo-quota': '/USAGE/PLAN/LIMIT[@NAME="Off Peak"]/@MEGABYTES',

						'free-upload': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
						'free-download': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
						'free-uploadpo': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@UPLOADS',
						'free-downloadpo': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Off Peak"]/@DOWNLOADS',
					},
					// normal
					{
						'XPATHVERIFY': '/USAGE[@VERSION="2"]/TRAFFIC',
						'planname': '/USAGE/PLAN/@DESCRIPTION',

						'startdate': '/USAGE/@START_DATE',
						'enddate': '/USAGE/@END_DATE',

						//'upload': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
						//'download': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
						//'download-quota': '/USAGE/PLAN/LIMIT[@NAME="Standard"]/@MEGABYTES',
						'upload': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
						'download': '/USAGE/TRAFFIC[@DESCRIPTION="Normal Billable Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
						'download-quota': '/USAGE/PLAN/LIMIT[@NAME="Peak"]/@MEGABYTES',

						//'free-upload': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@UPLOADS',
						//'free-download': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Standard"]/@DOWNLOADS',
						'free-upload': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@UPLOADS',
						'free-download': '/USAGE/TRAFFIC[@DESCRIPTION="Free Traffic"]/DATA[@TYPE="Peak"]/@DOWNLOADS',
					},
					{
						'error': '/opt/@ERROR',
					}
				],


				null
			],

			processVisitUsagePage: 'POST https://my.netspace.net.au/logincheck dest=%2Fusage-meter%2F&username={USERNAME}&password={PASSWORD}&Submit=Next',

			varMap: {
				// if passed through step 1 branch 0
				'0,0': {
					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
				'0,1': {
					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'0,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Upload': ['{upload}', '{uploadpo}'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Free Upload': ['{free-upload}', '{free-uploadpo}'],
					'Free Download': ['{free-download}', '{free-downloadpo}'],
				},
				'0,1': {
					'Upload': '{upload}',
					'Download': '{download} / {download-quota}',
					'Free Upload': '{free-upload}',
					'Free Download': '{free-download}',
				},
			},
			
		};
		
	case 'tpgi':
		return {
			description: 'Important! Please enter your monthly download quota below:',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://cyberstore.tpg.com.au/your_account/index.php check_username={USERNAME}&password={PASSWORD}&Submit=GO%21',
				[/Invalid username or customer ID or password/, /./],
				
				// step 1
				null,
				'GET https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage',
				[ 
					/<b>Package Type:<\/b> ([A-Za-z 0-9\.\+\/]+)[^`]+?<b>Download Charges:<\/b> ([A-Za-z0-9 :]+)[^`]+?Expiry Date:<\/b> ([A-Za-z0-9 ]+)[^`]+?Charges: (\$[0-9\.]+)[^`]+?Download used: ([0-9\.]+) MB/,
				],
				
				// step 2
				null,
				'GET https://cyberstore.tpg.com.au/your_account/index.php?function=logout',
				null,

				null
			],

			processVisitUsagePage: 'POST https://cyberstore.tpg.com.au/your_account/index.php?function=checkaccountusage check_username={USERNAME}&password={PASSWORD}&Submit=GO%21',

			varMap: {
				// if passed through step 1 branch 0
				'1,0': {
					'planname': '1:1',
					'enddate': '1:3', // rolldate startdate enddate
					'download': '1:5',
					'excesscharges': '1:2',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'1,0': {
					'Download': '{download} / {download-quota}',
				}
			},
		};

	case 'iinet':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,3': null,
			},
			process: [
				//step 0 , preprocess, chop off @iinet
				function(vars) {
					var u = vars['USERNAME'].split(/@/);
					if (u.length > 1 && u[1].substr(0, 6) == 'iinet.')
						vars['USERNAME'] = u[0];
				},
				'POST https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi action=login&username={USERNAME}&password={PASSWORD}',
				[
					/([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?Bliinkzone[^`]+?Bliinktime[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
					/([0-9]+) MB Peak time, ([0-9]+) MB[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
					/([0-9]+) MB[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A>[^`]+?volumegraphs\.cgi\?action=showday.+?>([0-9]{2}-[0-9]{2}-[0-9]{4})<\/A><\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<TD>[^<]+<\/TD>[\n\r ]+<\/TR>[\n\r ]+<TR ALIGN=right BGCOLOR=#ebebff>[\n\r ]+<TD>&nbsp;<\/TD>[\n\r ]+<TD ALIGN=left><B>Total<\/B><\/TD>[\n\r ]+<TD><B>&nbsp;<\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>[\n\r ]+<TD><B>([\.0-9]+)<\/B><\/TD>/,
					/Enter your username and password/
				],

				null
			],

			processVisitUsagePage: 'POST https://toolbox.iinet.net.au/cgi-bin/volumegraphs.cgi action=login&username={USERNAME}&password={PASSWORD}',

			varMap: {
				'0,0': { // old bliink
					'startdate': '0:3',
					'enddate': '0:4',
					'download': '0:5',
					'downloadpo': '0:7',
					'download-quota': '0:1',
					'downloadpo-quota': '0:2',
					'free-usage': '0:6',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
				'0,1': { // new ii2
					'startdate': '0:3',
					'enddate': '0:4',
					'download': '0:5',
					'downloadpo': '0:6',
					'download-quota': '0:1',
					'downloadpo-quota': '0:2',
					'free-usage': '0:7',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
				'0,2': { // new ii2 biz (no offpeak)
					'startdate': '0:2',
					'enddate': '0:3',
					'download': '0:4',
					'downloadpo': '0:5',
					'free-usage': '0:6',

					'usage': '0:7',
					'usage-quota': '0:1',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Free (Bliinkzone)': ['{free-usage}', ''],
				},
				'0,1': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Free': ['{free-usage}', ''],
				},
				'0,2': {
					'Download total': '{usage} / {usage-quota}',
					'Download (Peak)': '{download}',
					'Download (Offpeak)': '{downloadpo}',
					'Free': '{free-usage}',
				},
			},
		};

	case 'internode':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'POST https://accounts.internode.on.net/cgi-bin/padsl-usage username={USERNAME}&password={PASSWORD}',
				[ 
					/([0-9\.]+) ([0-9]+) ([0-9\/]+)/,
					/([^\r\n]+)/,
				],

				null
			],

			processVisitUsagePage: 'POST https://accounts.internode.on.net/cgi-bin/login username={USERNAME}&password={PASSWORD}&access=Personal_ADSL',

			varMap: {
				'0,0': {
					'rolldate': '0:3',
					'download': '0:1',
					'download-quota': '0:2',

					'usage': 'download',
					'usage-quota': 'download-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Download': '{download} / {download-quota}',
				}
			},

		};
		
	case 'optus':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'POST https://memberservices.optuszoo.com.au/myusage/usage.txt login={USERNAME}&passwd={PASSWORD}',
				[ 
					/end=([0-9\-]+)[^`]+?last=([0-9:\- ]+)[^`]+?offpeak_usage=([0-9]+)MB[^`]+?plan_limit=([0-9]+)MB[^`]+?plan_name=([^\r\n]+)[^`]+?plan_offpeak=([0-9]+)MB[^`]+?start=([0-9\-]+)[^`]+?usage=([0-9]+)MB/,
					/error=1[^`]+?reason=([^\r\n]+)/,
				],

				null
			],

			processVisitUsagePage: 'POST https://memberservices.optuszoo.com.au/login/?target=/myusage/ Action=login&username={USERNAME}&password={PASSWORD}',

			varMap: {
				'0,0': {
					'planname': '0:5',
					'startdate': '0:7',
					'enddate': '0:1',
					'download': '0:8',
					'downloadpo': '0:3',
					'download-quota': '0:4',
					'downloadpo-quota': '0:6',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'COLUMNHEADING': ['Peak', 'Offpeak'],
					'Last Update': ['{0:2}', ''],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				}
			},

		};
	
	case 'adam':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'GETBASIC http://members.adam.com.au/um1.2/',
				[ 
					{
						'XPATH_VERIFY': '/response/UsageMeter/Version',
						'upload': '/response/Account/SubAccount/MegabytesUploadedTotal',
						'download': '/response/Account/SubAccount/MegabytesDownloadedExternal',
						'download-quota': '/response/Account/MegabyteQuota',
						'downloadpo': '/response/Account/SubAccount/MegabytesDownloadedTotal - /response/Account/SubAccount/MegabytesDownloadedExternal',
						'downloadpo-quota': '/response/Account/MegabyteQuota',
						'startdate': '/response/Account/QuotaStartDate',
						
						'recorded': '/response/Account/SubAccount/LastUpdate',
					},
				],

				null
			],

			processVisitUsagePage: 'POST http://members.adam.com.au/index.php Username={USERNAME}&Password={PASSWORD}&Login=Log+In',

			varMap: {
				'0,0': {
					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo', // internal
					'usagepo-quota': 'downloadpo-quota',
					
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'COLUMNHEADING': ['External', 'Internal'],
					'Last update': ['{recorded}', ''],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Upload': ['{upload}', ''],
				}
			},
		};
		
	case 'chariot':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'USERNAME': 'Email',
				'ssfstate': ['State', PREF_TYPE_STRING | PREF_FLAG_GENERAL | PREF_FLAG_REQUIRED,
					{ 'NSW': '2', 
					 'QLD': '1',
					 'VIC': '3',
					 'SA': '4',
					 'TAS': '5',
					 'NT': '6',
					 'WA': '7', },
					],
			},
			vars: {
			},

			branching: {
				'0,0': null,
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi action=login&SearchServerFirst={ssfstate}&u={USERNAME}&p={PASSWORD}&SrchSrvrFrst={ssfstate}&submit=Enter+Account+Tools',
				[
					/Username not found/,
					/<span style="color:#ff0000">([^<]+)/,
					/<input type="hidden" name="sId" value="([^"]*)" \/><input type="hidden" name="cerb" value="([^"]*)" \/><input type="hidden" name="thistime" value="([^"]*)" \/><input type="hidden" name="action" value=""><input type="hidden" name="rawval" value="([^"]*)"><input type="hidden" name="popWnd" value="([^"]*)">[^`]+?<br>([\-0-9]+) \/ ([0-9]+)kb \([^`]+?<br>([\-0-9]+) \/ ([0-9]+)kb \(/,
				],
				
				// step 1
				null,
				'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Account+Usage&rawval={0:4}&popWnd={0:5}',
				[ 
					// /<\/table>[\s]+<br>([0-9]+) \/ ([0-9]+) mb[^`]+?<td align=center valign=bottom><font size=1 face=arial><b>([0-9]+)[^`]+?Last&nbsp;Update:&nbsp;([0-9\/ :]+)&nbsp; &nbsp; &nbsp;[\s]+Total&nbsp;Downloaded:&nbsp;([0-9\.]+)[^`]+?Last&nbsp;Update:&nbsp;([0-9\/ :]+)&nbsp; &nbsp; &nbsp;[\s]+Total&nbsp;Uploaded:&nbsp;([0-9\.]+)/,
					/<\/table>[\s]+<br>([0-9]+) \/ ([0-9]+) mb[^`]+?/
				],

				// step 1
				null,
				'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Account+Status&rawval={0:4}&popWnd={0:5}',
				[ 
					/Plan type[\s]+<\/td><td>[\s]+([^\n\r]+)[^`]+?Next due date[\s]+<\/td><td>[\s]+([0-9\\/]+)/
				],

				// step 3
				null,
				'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi sId={0:1}&cerb={0:2}&thistime={0:3}&action=Logout&rawval={0:4}&popWnd={0:5}',
				null,

				null
			],

			processVisitUsagePage: 'POST https://secure.chariot.net.au/cgi-bin/manageyouraccount/manageyouraccount.cgi action=login&SearchServerFirst=2&u={USERNAME}&p={PASSWORD}&SrchSrvrFrst=2&submit=Enter+Account+Tools',

			varMap: {
				// if passed through step 1 branch 0
				'1,0': {
					'planname': '2:1',
					'rolldate': '2:2', // rollday startdate enddate
					'download': '1:1',
					'download-quota': '1:2',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'1,0': {
					'Download': '{download} / {download-quota}',
					'Email space used': '{0:6} / {0:7}',
					'Web space used': '{0:8} / {0:9}',
				}
			},
		};
		
	case 'westnet':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null, // SearchServerFirst corresponds to a state, currently hardcoded
				'POST https://secure1.wn.com.au/webservices/customer/ADSLUsage/adslxmlusage.asmx/getUsage username={USERNAME}&password={PASSWORD}',
				[
					/xmlns:xsi="http:\/\/www.w3.org\/2001\/XMLSchema-instance" xsi:nil="true"/,
					/<usagelimit>([0-9]+) \/ ([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>[^`]*<offpeakused>([0-9\.,]+)<\/offpeakused>[^`]*<offpeakfree>([0-9\.,]+)<\/offpeakfree>/,
					/<usagelimit>([0-9]+)<\/usagelimit>[^`]*<peakused>([0-9\.,]+)<\/peakused>[^`]*<peakfree>([0-9\.,]+)<\/peakfree>/,
				],
				
				null
			],

			processVisitUsagePage: 'POST https://myaccount.westnet.com.au/Login.aspx?ReturnUrl=%2fTechnical%2fUsage%2fDefault.aspx tbUsername={USERNAME}&tbPassword={PASSWORD}',

			varMap: {
				'0,1': {
					'download': '0:3',
					'downloadpo': '0:5',
					'download-quota': '0:1',
					'downloadpo-quota': '0:2',
					'free-usage': '0:4',
					'free-usagepo': '0:6',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
				'0,2': {
					'download': '0:2',
					'download-quota': '0:1',
					'free-usage': '0:3',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,1': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Free Download': ['{free-usage}', '{free-usagepo}'],
				},
				'0,2': {
					'Download': '{download} / {download-quota}',
					'Free Download': '{free-usage}',
				},
			},
		};

		
	case 'unwired':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://www.unwired.com.au/myaccount/login.php?ev=nx login_name={USERNAME}&login_password={PASSWORD}&loginbutton=Login',
				[/Login failed/, /./],
				
				// step 1
				null,
				'GET https://www.unwired.com.au/myaccount/usage.php',
				[ 
					/My current plan is: ([A-Za-z0-9 \/]+)[^`]+?My current usage allowance: ([0-9]+)[^`]+?usage.php">([A-Za-z0-9\-]+) - ([A-Za-z0-9\-]+)[^`]+?Total<\/td>[\r\n 	]+<td>([0-9\.]+)<\/td>[\r\n 	]+<td>([0-9\.]+)/,
				],
				
				// step 2
				null,
				'GET https://www.unwired.com.au/myaccount/logout.php',
				null,

				null
			],
			
			strToInt: function (m, s, isp) {
				var i = parseInt(s, 10);
				if (m == 'download-quota' || m == 'usage-quota' || m == 'progress1max')
					return (i < 300) ? i*1000 : i;
				else
					return i;
			},

			processVisitUsagePage: 'POST https://www.unwired.com.au/myaccount/login.php?ev=nx login_name={USERNAME}&login_password={PASSWORD}&loginbutton=Login',

			varMap: {
				'1,0': {
					'planname': '1:1',
					'startdate': '1:3',
					'enddate': '1:4',
					'upload': '1:5',
					'download': '1:6',
					'download-quota': '1:2',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'1,0': {
					'Download': '{download} / {download-quota}',
				}
			},
		};
		
		
	case 'aanet':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'USERNAME': 'ADSL Phone Number',
				'download-quota': ['Download Quota (MB) (Optional)', PREF_TYPE_INT]
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'GET https://www.aanet.com.au/usage2.php?{USERNAME},{PASSWORD}',
				[ 
					/([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,\r\n]+)/,
					/([^\r\n]+)/,
				],

				null
			],

			processVisitUsagePage: 'POST https://www.aanet.com.au/members/checkuser.php username={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			strToInt: function (m, s, isp) {
				if (m == 'upload' || m == 'download' || m == 'usage' || m == 'progress1')
					return Math.round(parseInt(s, 10)/1024000);
				else
					return parseInt(s, 10);
			},

			varMap: {
				'0,0': {
					'planname': '0:7',
					'rolldate': '0:4',
					'upload': '0:1',
					'download': '0:2',
					'download-quota': '0:5',

					'usage': 'download',
					'usage-quota': 'download-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Last Updated': '{0:3}',
					'Upload': '{upload}',
					'Download': '{download} / {download-quota}',
				}
			},

		};
		
	case 'exetel':
		return {
			description: 'Please enter your usage quota and start day below.',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'typeurl': ['Service', PREF_TYPE_STRING | PREF_FLAG_GENERAL | PREF_FLAG_REQUIRED,
					{ 'ADSL': 'members',
					 'Wireless': 'wireless_login' }
					],
				'rolldate': ['Start Day of Month', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'download-quota': ['Peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'downloadpo-quota': ['Offpeak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'1,0': null,
			},
			process: [
				//step 0
				null,
				'GET https://www.exetel.com.au/{typeurl|NOESC}/',
				null,

				// step 1
				null,
				'POST https://www.exetel.com.au/{typeurl|NOESC}/ login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',
				[
					/The Service Number and Password you have entered is invalid/,
					/./
				],
				
				// step 2
				null,
				'GET https://www.exetel.com.au/{typeurl|NOESC}/usage_monthly_query.php',
				[
					/Total:[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>[^`]+?<b>([0-9\.]+)<\/b>/
				],
				
				// step 3
				null,
				'GET https://www.exetel.com.au/{typeurl|NOESC}/logout.php',
				null,

				null
			],

			processVisitUsagePage: 'POST https://www.exetel.com.au/members/usage_monthly_query.php login_name={USERNAME}&password={PASSWORD}&doLogin=1&submit=+Login+',

			varMap: {
				'2,0': {
					'upload': '2:3',
					'uploadpo': '2:1',
					'download': '2:4',
					'downloadpo': '2:2',

					'usage': 'download',
					'usagepo': 'downloadpo',
					'usage-quota': 'download-quota',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'2,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Upload': ['{upload}', '{uploadpo}'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				}
			},
		};
		
		
	case 'onthenet':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
			},
			process: [
				//step 0
				null,
				'GETBASIC http://dslstats.onthenet.com.au/{USERNAME}/',
				null,
				
				//step 1
				null,
				'GETBASIC http://dslstats.onthenet.com.au/services/usageCurrent/{USERNAME}',
				[ 
					/Plan -<\/b> ([A-Za-z0-9 \-\/]+)[^`]+?nowrap>[\s]+([0-9\-]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>[\s]+([0-9]+)[^`]+?nowrap>([0-9]+)[^`]+?nowrap>([0-9]+)/,
				],

				null
			],

			processVisitUsagePage: 'GETBASIC http://dslstats.onthenet.com.au/services/usageCurrent/{USERNAME}',

			varMap: {
				'1,0': {
					'planname': '1:1',
					'startdate': '1:2',
					'download': '1:4',
					'downloadpo': '1:6',
					'download-quota': '1:3',
					'downloadpo-quota': '1:5',
					'upload': '1:8',
					
					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'1,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Upload': ['{upload}', ''],
				}
			},

		};
		
	case 'netcall':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'GET https://www.netcall.com.au/usage2.php?{USERNAME},{PASSWORD}',
				[ 
					/([0-9]+),([0-9]+),([0-9:\- ]+),([0-9]+),([0-9]+),([^,]+),([^,]+)/,
					/([^\r\n]+)/,
				],

				null
			],

			processVisitUsagePage: 'POST https://www.netcall.com.au/members.html servicenumber={USERNAME}&password={PASSWORD}',

			strToInt: function (m, s, isp) {
				if (m == 'download-quota' || m == 'usage-quota' || m == 'progress1max')
					return parseInt(s, 10);
				else
					return Math.round(s/1048576);
			},

			varMap: {
				'0,0': {
					'planname': '0:7',
					'rolldate': '0:4',
					'upload': '0:1',
					'download': '0:2',
					'download-quota': '0:5',

					'usage': 'download',
					'usage-quota': 'download-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Recorded': '{0:3}',
					'Download': '{download} / {download-quota}',
				}
			},

		};

	case 'westvic':
		return {
			description: 'Please enter your Download Allowance',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Download quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'downloadpo-quota': ['Off-peak Download quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				function(vars) { if (!vars['USERNAME'].match(/.*\@westvic$/)) vars['USERNAME'] = vars['USERNAME']+"@westvic"; },
				'POST http://accounts.westvic.com.au/LOGIN credential_0={USERNAME}&credential_1={PASSWORD}&submit=Login&destination=%2F',
				[ 
					/type="password" class="login" id="secretkey"/,
					/<b>Total<\/b><\/font>[^`]+?<b>([0-9\.]+) MB[^`]+?<b>([0-9\.]+) MB[^`]+?<b>Total<\/b><\/font>[^`]+?<b>([0-9\.]+) MB[^`]+?<b>([0-9\.]+) MB/,
				],
				

				null
			],

			processVisitUsagePage: 'POST http://accounts.westvic.com.au/LOGIN credential_0={USERNAME}%40westvic&credential_1={PASSWORD}&submit=Login&destination=%2F',

			varMap: {
				'0,1': {
					'upload': '0:1',
					'download': '0:2',
					'uploadpo': '0:3',
					'downloadpo': '0:4',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'0,1': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Upload': ['{upload}', '{uploadpo}'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				}
			},

		};
		

	case 'gnode':
		return {
			description: 'Please enter your download quota.',
			
			intUnit: UNIT_GB,
			
			prefs: {
				'download-quota': ['Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
				'1,0': 2,
				'2,0': 100,
				'2,1': 100,
				'1,1': 3,
				'3,0': 100,
				'3,1': 100,
			},
			process: [
				//step 0
				null,
				'POST https://www.g-node.com.au/login.asp username={USERNAME}&password={PASSWORD}',
				[/Incorrect username or password/, /./],
				
				// step 1
				null,
				'GET https://www.g-node.com.au/services.asp',
				[ 
					/href="metering_gtime.asp[^`]+?recordid" value="([0-9]+)/,
					/href="metering.asp[^`]+?recordid" value="([0-9]+)/,
				],

				// step 2
				null,
				'GET https://www.g-node.com.au/metering_gtime.asp?recordID={1:1}',
				[ 
 					//                                      {1}                                                                                         {2}
					/<td width="100"><div align="right">\s*([\d.]+)\s*GB[^`]+?Monthly Total:<\/td>\s*<td width="100"><div align="right">[^`]+?right">\s*([\d.]+)\s*GB/,
					/Monthly Total \(excluding G-time\):<\/td>[^`]+?<td width="100"><div align="right">\s*([\d.]+)\s*MB[^`]+?Monthly Total:<\/td>\s*<td width="100"><div align="right">[^`]+?right">\s*([\d.]+)\s*MB/,
       				],
				
				// step 3
				null,
				'GET https://www.g-node.com.au/metering.asp?recordID={1:1}',
				[ 
					/Monthly Total:<\/td>\s*<td width="100"><div align="right">[^`]+?right">\s*([\d.]+)\s*GB/,
					/Monthly Total:<\/td>\s*<td width="100"><div align="right">[^`]+?right">\s*([\d.]+)\s*MB/,
				],

				// step 4 - LOGOUT code commented out. Unsure if it is required.
				//null,
				//'GET https://www.g-node.com.au/logout.asp',
				//null,

				// post process function
				function(vars) {
					if (vars['2'] == 0) { // passed through step 2 branch 0
						// free = total (2:2) - download (2:1);
						vars['free-download'] =  (parseFloat(vars['2:2'], 10) - parseFloat(vars['2:1'], 10))*1000;
					}
					if (vars['2'] == 1) { // passed through step 2 branch 1
						// free = total (2:2) - download (2:1);
						vars['free-download'] =  parseInt(vars['2:2'], 10) - parseInt(vars['2:1'], 10);
						// Force unit to MB
						vars['download'] = parseInt(vars['2:1'], 10);
					}
					if (vars['3'] == 1) { // passed through step 3 branch 1
						// Force unit to MB
						vars['download'] = parseInt(vars['3:1'], 10);
					}
				}
			],

			// VisitUsagePage is broken - Can't get the recordid variable to insert correctly.
			processVisitUsagePage: 'GET https://www.g-node.com.au/metering_gtime.asp?recordID={1:1}',

			varMap: {
				// if passed through step 2 branch 0
				'2,0': {
					'download': '2:1',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
				// if passed through step 2 branch 1				
				'2,1': {
					'download': '2:1',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},				

				// if passed through step 3 branch 0
				'3,0': {
					'download': '3:1',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
				// if passed through step 3 branch 1				
				'3,1': {
					'download': '3:1',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},

			},
			
			varsDisplay: {
				// if passed through step 2 branch 0
				'2,0': {
					'Metered Downloads': '{download}  MB',
					'G-Time Downloads': '{free-download} MB',
				},
				// if passed through step 2 branch 1
				'2,1': {
					'Metered Downloads': '{download}  MB',
					'G-Time Downloads': '{free-download} MB',
				},

				// if passed through step 3 branch 0
				'3,0': {
					'MB Downloaded': '{download}',
				},
				// if passed through step 3 branch 1				
				'3,1': {
					'MB Downloaded': '{download}',
				},

			},
		};
		
		
	case 'kern': 
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
			},
			process: [
				//step 0
				null,
				'GETBASIC http://mozart.kern.com.au/custdata/time-block-list.php3',
				/<TD CLASS=cols1>([0-9A-Za-z ]+) - ([0-9A-Za-z ]+)<\/TD>[\s]+<TD CLASS=cols0>([A-Za-z0-9\/ \+\-]+)[^`]+?([0-9]{2,})&[^`]+?<TD CLASS=cols0>([0-9:]+)<BR>([0-9\.]+)MB<BR>\(([0-9\.]+)MB Free/,
				
				null
			],

			processVisitUsagePage: 'GETBASIC http://mozart.kern.com.au/custdata/time-block-list.php3',

			varMap: {
				'0,0': {
					'startdate': '0:1',
					'enddate': '0:2',
					'planname': '0:3',
					'download-quota': '0:4',
					'timeused': '0:5',
					'download': '0:6',
					'free': '0:7',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Downloads': '{download} / {download-quota}',
					'Free': '{free}',
					'Time used': '{timeused}',
				},
			},
		};
		
	
	case 'comcen':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'USERNAME': 'DSL Number',
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				null,
				'POST http://star.comcen.com.au/cgi-bin/user-services.cgi username={USERNAME}&password={PASSWORD}',
				[/Login failed please retry/, /./],
				
				null,
				'GET http://star.comcen.com.au/cgi-bin/dslusage.cgi?displayunit=MB',
				/Billing Period:<\/b><\/font><\/td><td><font size="1">([0-9 A-Za-z]+) - ([0-9 A-Za-z]+)[^`]+?([0-9]+) MB Peak \/ ([0-9]+) MB Offpeak[^`]+?([0-9\.]+)<\/td><td class="smalltext">([0-9\.]+)<\/td><td class="smalltext" bgcolor="[^"]+">([0-9\.]+)<\/td><td class="smalltext">([0-9\.]+)<\/td><\/tr>[\r\n]{1}/,
				
				null,
				'GET http://star.comcen.com.au/cgi-bin/user-services.cgi?logout=1',
				null,

				null
			],

			processVisitUsagePage: 'POST http://star.comcen.com.au/cgi-bin/user-services.cgi username={USERNAME}&password={PASSWORD}',

			varMap: {
				'1,0': {
					'startdate': '1:1',
					'enddate': '1:2',
					'upload': '1:6', // weird small num
					'download': '1:5',
					'uploadpo': '1:8', // weird small num
					'downloadpo': '1:7',
					'download-quota': '1:3',
					'downloadpo-quota': '1:4',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'1,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
				},
			},
		};

	case 'wideband':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				null,
				'POST https://my.wideband.net.au/ destination=%2F&login_username={USERNAME}&login_password={PASSWORD}',
				[/Username or password was incorrect/, /./],
				
				null,
				'GET https://my.wideband.net.au/usage.php',
				/Total Used<\/strong>[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?<strong>([0-9\.]+) MB[^`]+?Last updated: ([^<]+)/,
				
				function (vars) {
					vars['1:5'] = parseInt(vars['1:5'], 10) + parseInt(vars['1:2'], 10); // peak quota
					vars['1:6'] = parseInt(vars['1:6'], 10) + parseInt(vars['1:4'], 10); // offpeak quota
				},
				'GET https://my.wideband.net.au/logout.php',
				null,

				null
			],

			processVisitUsagePage: 'POST https://my.wideband.net.au/ destination=%2F&login_username={USERNAME}&login_password={PASSWORD}',

			varMap: {
				'1,0': {
					'upload': '1:1',
					'download': '1:2',
					'uploadpo': '1:3',
					'downloadpo': '1:4',
					'download-quota': '1:5',
					'downloadpo-quota': '1:6',
					'recorded': '1:7',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'1,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Upload': ['{upload}', '{uploadpo}'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Last updated': ['{recorded}', ''],
				},
			},
		};


	case 'mackaycs':
		return {
			description: 'Important! Please enter your monthly quota below:',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'usage-quota': ['Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST http://manage.mcs.net.au/custinfo/login.asp smallres=1&username={USERNAME}&password={PASSWORD}&goto=&x=84&y=17',
				[/Either your userid or password were invalid/, /./],
				
				// step 1
				null,
				'GET http://manage.mcs.net.au/custinfo/usage.asp?button=usage',
				[ 
					/Usage from ([0-9A-Za-z, ]+?) to[^`]+?TOTAL<\/TD><TD>([0-9:]+) <\/TD><TD>([0-9\.]+)<\/TD><TD>([0-9\.]+)<\/TD><TD>([0-9.]+)/,
				],
				
				// step 2
				null,
				'GET http://manage.mcs.net.au/custinfo/login.asp?type=logout',
				null,

				null
			],

			processVisitUsagePage: 'POST http://manage.mcs.net.au/custinfo/login.asp smallres=1&username={USERNAME}&password={PASSWORD}&goto=&x=84&y=17',

			varMap: {
				// if passed through step 1 branch 0
				'1,0': {
					'startdate': '1:1',
					'upload': '1:3',
					'download': '1:4',
					'timeonline': '1:2',

					'usage': '1:5',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'1,0': {
					'Used': '{usage} / {usage-quota}',
					'Upload': '{upload}',
					'Download': '{download}',
					'Time': '{timeonline}',
				}
			},
		};



		
	case 'peopletelecom':
		return {
			description: '',
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://www.peopleservice.com.au/login.php jclerk_id={USERNAME}&passwd={PASSWORD}',
				[/<span class="accountname"><\/span>/, /./],
				
				// step 1
				null,
				'GET https://www.peopleservice.com.au/login.php?login2=Y&jclerk_id={USERNAME}',
				null,
				
				// step 2
				null,
				'GET http://www.peopleservice.com.au/sdocs.php?swiftservicetrafficaccountingselectservice=Y',
				[ 
					/<font color="#d70079">\[([0-9\/]+)[^`]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+<td align=right><b class="c9"><font color=white>([0-9\.]+)<\/font><\/b><\/a><\/td>[\s]+/,
				],
				
				// step 3
				null,
				'GET http://www.peopleservice.com.au/login.php?logout=Y',
				null,

				null
			],
			
			processVisitUsagePage: 'POST https://www.peopleservice.com.au/login.php jclerk_id={USERNAME}&passwd={PASSWORD}',

			varMap: {
				// if passed through step 1 branch 0
				'2,0': {
					'startdate': '2:1',
					'download': '2:2',
					'free-download': '2:3', // peering
					'downloadpo': '2:4', // internal

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'2,0': {
					'Download': '{download} / {download-quota}',
					'Peering': '{free-download}',
					'Internal': '{downloadpo}',
				}
			},
		};
		
	case 'clearnetworks':
		return {
			description: '',
			intUnit: UNIT_MB,
			
			prefs: {
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://www.clearnetworks.com.au/myaccount.html accNumber={USERNAME}&accPassword={PASSWORD}&sessionID=&B1=Login',
				[
					/Authorisation Failed/,
					/sessionID" value="([^"]+)[^`]+?accNumber" value="([^"]+)/
				],
				
				// step 1
				null,
				'POST https://www.clearnetworks.com.au/myaccount.html sessionID={0:1}&accNumber={0:2}&accOption=Check+Usage&sessionID={0:1}&accNumber={0:2}&CurrentPass=&NewPass=&NewPassVerify=',
				[ 
					/Current Plan:<\/b><\/td><td>([^<]+)<\/td><\/tr>[^`]+?<tr><td><b>Data Included:<\/b><\/td><td>([0-9]+) GB<\/td><\/tr>[\s]+<tr><td><b>Last Update:<\/b><\/td><td><font color=red>([^<]+)[^`]+?Data usage this period:<\/td><td>&nbsp;([0-9\.]+)/,
				],
				

				null
			],
			strToInt: function (m, s, isp) {
				var i = parseInt(s, 10);
				if (m == 'download-quota' || m == 'usage-quota' || m == 'progress1max')
					return i*1000;
				else
					return i;
			},
			
			processVisitUsagePage: 'POST https://www.clearnetworks.com.au/myaccount.html accNumber={USERNAME}&accPassword={PASSWORD}&sessionID=&B1=Login',
		
			varMap: {
				// if passed through step 1 branch 0
				'1,0': {
					'planname': '1:1',
					'download': '1:4',
					'download-quota': '1:2', // internal

					'usage': 'download',
					'usage-quota': 'download-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'1,0': {
					'Last Update': '{1:3}',
					'Download': '{download} / {download-quota}',
				}
			},
		
		};
		
	case 'velocitynet':
		return {
			description: '',
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'downloadpo-quota': ['Off-peak Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://toolbox.velocitynet.com.au/login_test.cfm login={USERNAME}&domain=velocitynet.com.au&pwd={PASSWORD}&x=60&y=9',
				[/You have entered an Incorrect Username\/Password combination/, /./],
				
				// step 1
				null,
				'GET https://toolbox.velocitynet.com.au/usage.cfm',
				[ 
					/display=detail&showtype=detail">([A-Za-z0-9 ]+)[^`]+?<td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>[^`]+?<td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>([0-9,\.]+)<\/b><\/font><\/td><td align="RIGHT"><font color="white"><b>/,
				],
				
				null
			],
			
			processVisitUsagePage: 'POST https://toolbox.velocitynet.com.au/login_test.cfm login={USERNAME}&domain=velocitynet.com.au&pwd={PASSWORD}&x=60&y=9',
			
			varMap: {
				'1,0': {
					'startdate': '1:1',
					'free-download': '1:2',
					'download': '1:3',
					'free-downloadpo': '1:4',
					'downloadpo': '1:5',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'1,0': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Free': ['{free-download}', '{free-downloadpo}'],
				},
			},
		
		};
		

	case 'amnet':
		return {
			description: 'Amnet are still fiddling, may cause this to break.',
			intUnit: UNIT_GB,
			
			prefs: {
			},
			vars: {
			},

			strToDate: function(m, s, isp) {
				var month, months, r;

				// Day, DD Mon YYYY
				r = s.match(/^\w+, (\d+) (\w+) (\d+)/);
				months = {'jan': 0, 'feb': 1, 'mar': 2, 'apr': 3, 'may': 4, 'jun': 5, 'jul': 6, 'aug': 7, 'sep': 8, 'oct': 9, 'nov': 10, 'dec': 11}
				month = months[r[2].toLowerCase()];

				return new Date(parseInt(r[3]), month, parseInt(r[1]), 0, 0, 0, 0);
			},

			branching: {
				'1,0': null,
				'3,0': null,
			},
			process: [
				// step 0
				null,
				'GET http://memberutils.amnet.com.au/ClientLogin.aspx',
				/id="__VIEWSTATE" value="([^"]+)"(?:.|\r|\n)*id="__EVENTVALIDATION" value="([^"]+)"/,

				//step 1
				null,
				'POST http://memberutils.amnet.com.au/ClientLogin.aspx __EVENTTARGET=&__EVENTARGUMENT=&__VIEWSTATE={0:1}&ctl00%24MemberToolsContent%24txtUsername={USERNAME}&ctl00%24MemberToolsContent%24txtPassword={PASSWORD}&ctl00%24MemberToolsContent%24btnLogin=Login&__EVENTVALIDATION={0:2}',
				[ /Your username\/password was incorrect/, /./ ],
				
				// step 2
				null,
				'GET http://memberutils.amnet.com.au/UsageDetails.aspx',
				/_planname">([^<]+)<(?:.|\r|\n)*_basicusage">(\d+)<(?:.|\r|\n)*_peeringusage">(\d+)<(?:.|\r|\n)*selected="selected" value="[^"]+">([^<]+)<(?:.|\r|\n)*Total usage:(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB(?:<[^>]+>|\s+)+(\d+\.\d+) GB/,
				
				// step 3
				null,
				'GET http://memberutils.amnet.com.au/ClientLogoff.aspx',
				null,

				null
			],
			
			processVisitUsagePage: 'GET http://memberutils.amnet.com.au/ClientLogin.aspx',
		
			varMap: {
				// if passed through step 2 branch 0
				'2,0': {
					'planname': '2:1',
					'startdate': '2:4',
					'download': '2:5', // basic
					'download-quota': '2:2',
					'upload': '2:6',
					'downloadpo': '2:7', // peering
					'downloadpo-quota': '2:3',
					'uploadpo': '2:8',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				// if passed through step 1 branch 0
				'2,0': {
					'COLUMNHEADING': ['Basic', 'Peering'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Upload': ['{upload}', '{uploadpo}'],
				}
			},
		
		};
	
	case 'wildit':
		return {
			description: 'Please enter your Usage Allowance!',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Download Allowance (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED]
			},
			vars: {
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'POST https://members.wildit.net.au/area/login.pl action=login&user={USERNAME}&password={PASSWORD}',
				[
					/;url="([^"]+)/,
					/Your Login is invalid please retry/,
				],
				
				//step 1
				null,
				'GET {0:1|NOESC}',
				[
					/action="([^"]+)"><input type="hidden" name="([^"]+)" value="([^"]+)"><input type="hidden" name="action" value="fullusage">/,					
				],
				
				null,
				'POST https://members.wildit.net.au/area/{1:1} {1:2}={1:3}&action=fullusage',
				[ 
					/([0-9:]+)<\/td><td class="Cell2" align="right" colspan="1">([0-9,\.]+)<\/td><td class="Cell2" align="right" colspan="1">([0-9,\.]+)/,
				],

				null
			],

			processVisitUsagePage: 'POST https://members.wildit.net.au/area/login.pl action=login&user={USERNAME}&password={PASSWORD}',

			varMap: {
				'2,0': {
					'upload': '2:3',
					'download': '2:2',

					'usage': 'download',
					'usage-quota': 'download-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'2,0': {
					//'Online duration': '2:1',
					'Upload': '{upload}',
					'Download': '{download} / {download-quota}',
				}
			},

		};
		
	case 'netxp':
		return {
			description: '',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'USERNAME': 'Username',
				'PASSWORD': null
			},
			vars: {
			},

			branching: {
				'0,2': null,
			},
			process: [
				//step 0
				null,
				'POST http://netxp.com.au/internet/netusage.php dialuser={USERNAME}',
				[ 
					/([^,]+),([0-9\-]+),([0-9\-]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),0,0,([0-9\-]+)/,
					/([^,]+),([0-9\-]+),([0-9\-]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\.]+),([0-9\-]+)/,
					/([^\r\n]+)/,
				],

				null
			],

			processVisitUsagePage: 'GET http://netxp.com.au/internet/?content=toolbox',

			varMap: {
				'0,0': {
					'planname': '0:1',
					'startdate': '0:2',
					'upload': '0:6',
					'download': '0:5',
					'download-quota': '0:4',

					'usage': 'download',
					'usage-quota': 'download-quota',

					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
				'0,1': {
					'planname': '0:1',
					'startdate': '0:2',
					'upload': '0:6',
					'download': '0:5',
					'download-quota': '0:4',
					'downloadpo': '0:8',
					'downloadpo-quota': '0:7',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Last Updated': '{0:7}',
					'Upload': '{upload}',
					'Download': '{download} / {download-quota}',
				},
				'0,1': {
					'COLUMNHEADING': ['Peak', 'Off-peak'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Upload': ['{upload}', ''],
					'Last Updated': '{0:9}',
				}
			},

		};
		
	//
	// Ukrainian
	//
	case 'volia': 
		return {
			description: 'Please enter your Usage Limits',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'download-quota': ['Ukrainian limit (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'downloadpo-quota': ['Foreign limit (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},
			
			strToInt: function (m, s, isp) {
				s = s+"";
				s = s.replace(/,/g, '.');
				return parseInt(s, 10);
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'POST https://stat.voliacable.com:8443/ktvinet/j_security_check j_username={USERNAME}&j_password={PASSWORD}',
				[/https:\/\/stat\.voliacable\.com:8443\/ktvinet\/login_error\.jsp/, /./],

				function (vars) {
					var n = new Date();
					vars['datefrom'] = (n.getDate() < 10 ? '0' : '') + n.getDate() + '-';
					vars['datefrom'] += (n.getMonth() < 10 ? '0' : '') + n.getMonth() + '-';
					vars['datefrom'] += n.getFullYear();
				},
				'POST https://stat.voliacable.com:8443/ktvinet/stats.do dateFrom={datefrom}&dateTo={datefrom}&okBtn4=%C7%E0+%F2%E5%EA%F3%F9%E8%E9+%EC%E5%F1%FF%F6',
				/<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[^`]+?<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<td align="right">([0-9,]+)<\/td>[\s]+<\/tr>[\s]+<tr bgcolor=silver >/,
				
				null,
				'GET https://stat.voliacable.com:8443/ktvinet/logout.jsp',
				null,
				
				null
			],

			processVisitUsagePage: 'POST https://stat.voliacable.com:8443/ktvinet/j_security_check j_username={USERNAME}&j_password={PASSWORD}',

			varMap: {
				'1,0': {
					'download': '1:1',
					'downloadpo': '1:6',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'downloadpo',
					'usagepo-quota': 'downloadpo-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'1,0': {
					'COLUMNHEADING': ['Ukrainian', 'Foreign'],
					'Download': ['{download} / {download-quota}', '{downloadpo} / {downloadpo-quota}'],
					'Cost in limit': ['{1:4}', '{1:9}'],
					'Cost over limit': ['{1:5}', '{1:10}'],
				},
			},
		};
		
	//
	// Belgium
	//

	case 'coditel':
		return {
			description: 'Important! Please enter your monthly quota below:',
			
			intUnit: UNIT_GB,
			
			prefs: {
				'USERNAME': 'ESN',
				'PASSWORD': null,
				'usage-quota': ['Quota (GB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},
			
			strToInt: function (m, s, isp) {
				s = s+"";
				s = s.replace(/,/g, '.');
				return parseFloat(s) * 1000;
			},

			branching: {
				'0,1': null,
			},
			process: [
				//step 0
				null,
				'GET http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN&SubmitButton=Request',
				[
					/Download used this month : ([0-9,]+) GBytes<br>Upload used this month : ([0-9,]+) GBytes<br><br><b>Total used this month : ([0-9,]+) GBytes/,
					/./,
				],

				null
			],

			processVisitUsagePage: 'GET http://www.coditel.net/ENcm_counters.asp?ESN={USERNAME}&action=CheckESN&SubmitButton=Request',

			varMap: {
				'0,0': {
					'download': '0:1',
					'upload': '0:2',

					'usage': '0:3',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
				},
			},
			
			varsDisplay: {
				'0,0': {
					'Used': '{usage} / {usage-quota}',
					'Download': '{download}',
					'Upload': '{upload}',
				}
			},
		};
		

	//
	// CANADA
	//

	case 'videotron': 
		return {
			description: 'Please enter your download and upload quota.',
			
			intUnit: UNIT_MB,
			
			prefs: {
				'PASSWORD': null,
				'download-quota': ['Download Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
				'upload-quota': ['Upload Quota (MB)', PREF_TYPE_INT | PREF_FLAG_REQUIRED],
			},
			vars: {
			},

			branching: {
				'0,0': null,
			},
			process: [
				//step 0
				null,
				'GET https://www.videotron.com/services/secur/ConsommationInternet.do?compteInternet={USERNAME}&lang=ENGLISH',
				[
					/Beware to entered your Internet username correctly/,
					/class="reg">([0-9\-]+) to ([0-9\-]+)<\/td>[^`]+?class="reg">([0-9\.]+)[^`]+?class="reg">[0-9\.]+[^`]+?class="reg">([0-9\.]+)/,
				],
				null
			],

			processVisitUsagePage: 'GET https://www.videotron.com/services/secur/ConsommationInternet.do?compteInternet={USERNAME}&lang=ENGLISH',

			varMap: {
				'0,1': {
					'startdate': '0:1',
					'enddate': '0:2',
					'download': '0:3',
					'upload': '0:4',

					'usage': 'download',
					'usage-quota': 'download-quota',
					'usagepo': 'upload',
					'usagepo-quota': 'upload-quota',
					'progress1': 'usage',
					'progress1max': 'usage-quota',
					'progress2': 'usagepo',
					'progress2max': 'usagepo-quota',
				},
			},
			
			varsDisplay: {
				'0,1': {
					'COLUMNHEADING': ['Download', 'Upload'],
					'Usage (MB)': ['{download} / {download-quota}', '{upload} / {upload-quota}'],
				}
			},
		};




	}
	
	return null;

}
