/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2006, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
Net Usage Item

Function Library

*/

const __USAGELIB_JS__ = 1;

// load user's password
function nuLoadPass(ahost) {
	var passManInt = Components.classes['@mozilla.org/passwordmanager;1'].getService().QueryInterface(Components.interfaces.nsIPasswordManagerInternal);
	var fhost = {value: ''};
	var fuser = {value: ''};
	var fpassword = {value: ''};

	try {
		passManInt.findPasswordEntry(ahost, '', '', fhost, fuser, fpassword);
	} catch(e) {
		dump(e+'\n'); 
		return false;
	}

	return [fhost.value, fuser.value, fpassword.value];
}

// save user's password
function nuSavePass(ahost, ausername, apassword) {
	var passMan = this.Components.classes['@mozilla.org/passwordmanager;1'].getService().QueryInterface(this.Components.interfaces.nsIPasswordManager);

	while (todel = nuLoadPass(ahost)) {
		passMan.removeUser(ahost, todel[1]);
	}
	if (ausername != null) {
		passMan.addUser(ahost, ausername, apassword);
	}
}

// my new foolproof encode base64 for username/password auth :)
function nuEncodeBase64(str) {

	var b64 = [
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',   //  0 to  7
	'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',   //  8 to 15
	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',   // 16 to 23
	'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',   // 24 to 31
	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',   // 32 to 39
	'o', 'p', 'q', 'r', 's', 't', 'u', 'v',   // 40 to 47
	'w', 'x', 'y', 'z', '0', '1', '2', '3',   // 48 to 55
	'4', '5', '6', '7', '8', '9', '+', '/' ]; // 56 to 63

	var tfb = 0, res = '';
	
	// do a 3-to-4
	for (var i = 0; i < str.length; i += 3) {
		tfb = 0;
		tfb |= str.charCodeAt(i) << 16;
		if (i+1 < str.length) {
			tfb |= str.charCodeAt(i+1) << 8;
			if (i+2 < str.length)
				tfb |= str.charCodeAt(i+2);
		}
	
		res += b64[tfb >>> 18 & 63] 
			+ b64[tfb >>> 12 & 63] 
			+ b64[tfb >>> 6 & 63]
			+ b64[tfb & 63];
	}

	// take care of padding
	if (str.length % 3 == 1) {
		res = res.substr(0, 4*parseInt(str.length/3)+2)+'==';
	} else if (str.length % 3 == 2) {
		res = res.substr(0, 4*parseInt(str.length/3)+3)+'=';
	}

	return res;
}


function ndump(s) {
	dump("NETUSAGE >>> " + s + "\n");
}

function ndumpobj(objname, o) {
	dump('NETUSAGE >>> EEEEEEEEE '+objname+' = {\n');
	for (i in o) {
		dump(i+': '+o[i]+'\n');
	}
	dump('} EEEEEEEEEE\n');
}

function ndumpobjstr(objname, o) {
	var s = 'NETUSAGE >>> EEEEEEEEE '+objname+' = {\n';
	for (i in o) {
		s += i+': '+o[i]+'\n';
	}
	s += '} EEEEEEEEEE\n';
	return s;
}

function nuVarExpand(s, vars, defaultEscape) {
	return s.replace(/\{[A-Za-z0-9:_\-\|]+\}/g, function(vs) {
		var v = vs.substr(1, vs.length-2);
		var pidx = v.indexOf('|NOESC');
		if (pidx != -1)
			v = v.substr(0, pidx);
		
		if (typeof(vars[v]) == 'undefined')
			return vs;
		
		if (!defaultEscape || pidx != -1)
			return vars[v]; 
		else
			return encodeURIComponent(vars[v]);
	} );
}

function nuEscapeRegexp(s) {
	// escapes \ / * + ? | { } [ ] ( ) ^ $ . #
	return s.replace(/([\\\/\*\+\?\|\{\}\[\]\(\)\^\$\.\#]{1})/g, '\\$1');
}

function nuGetVersion() {
	var extMan = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var ext = extMan.getItemForID("{DA1B0AB5-7DD3-4066-BC2A-64AABBDD0A8B}");
	ext.QueryInterface(Components.interfaces.nsIUpdateItem);
	return ext.version;
}
